/[gentoo-x86]/eclass/mysql.eclass
Gentoo

Diff of /eclass/mysql.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.6 Revision 1.146
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.6 2006/01/14 19:00:32 vivo Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.146 2010/05/13 19:45:47 robbat2 Exp $
4 4
5# @ECLASS: mysql.eclass
6# @MAINTAINER:
5# Author: Francesco Riosa <vivo at gentoo.org> 7# Author: Francesco Riosa (Retired) <vivo@gentoo.org>
6# Maintainer: Francesco Riosa <vivo at gentoo.org> 8# Maintainers: MySQL Team <mysql-bugs@gentoo.org>
9# - Luca Longinotti <chtekk@gentoo.org>
10# - Robin H. Johnson <robbat2@gentoo.org>
11# @BLURB: This eclass provides most of the functions for mysql ebuilds
12# @DESCRIPTION:
13# The mysql.eclass provides almost all the code to build the mysql ebuilds
14# including the src_unpack, src_prepare, src_configure, src_compile,
15# scr_install, pkg_preinst, pkg_postinst, pkg_config and pkg_postrm
16# phase hooks.
7 17
8inherit eutils flag-o-matic gnuconfig mysql_fx 18WANT_AUTOCONF="latest"
19WANT_AUTOMAKE="latest"
9 20
10#major, minor only in the slot 21inherit eutils flag-o-matic gnuconfig autotools mysql_fx versionator toolchain-funcs
11SLOT=$(( ${MYSQL_VERSION_ID} / 10000 ))
12 22
13# shorten the path because the socket path length must be shorter than 107 chars 23# Shorten the path because the socket path length must be shorter than 107 chars
14# and we will run a mysql server during test phase 24# and we will run a mysql server during test phase
15S="${WORKDIR}/${PN}" 25S="${WORKDIR}/mysql"
16 26
27[[ "${MY_EXTRAS_VER}" == "latest" ]] && MY_EXTRAS_VER="20090228-0714Z"
28if [[ "${MY_EXTRAS_VER}" == "live" ]]; then
29 EGIT_PROJECT=mysql-extras
30 EGIT_REPO_URI="git://git.overlays.gentoo.org/proj/mysql-extras.git"
31 inherit git
32fi
33
34case "${EAPI:-0}" in
35 2)
36 EXPORT_FUNCTIONS pkg_setup \
37 src_unpack src_prepare \
38 src_configure src_compile \
39 src_install \
40 pkg_preinst pkg_postinst \
41 pkg_config pkg_postrm
42 IUSE_DEFAULT_ON='+'
43 ;;
44 0 | 1)
45 EXPORT_FUNCTIONS pkg_setup \
46 src_unpack \
47 src_compile \
48 src_install \
49 pkg_preinst pkg_postinst \
50 pkg_config pkg_postrm
51 ;;
52 *)
53 die "Unsupported EAPI: ${EAPI}" ;;
54esac
55
56
57# @ECLASS-VARIABLE: MYSQL_PV_MAJOR
58# @DESCRIPTION:
59# Upstream MySQL considers the first two parts of the version number to be the
60# major version. Upgrades that change major version should always run
61# mysql_upgrade.
62MYSQL_PV_MAJOR="$(get_version_component_range 1-2 ${PV})"
63
64# @ECLASS-VARIABLE: MYSQL_VERSION_ID
65# @DESCRIPTION:
66# MYSQL_VERSION_ID will be:
67# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99]
68# This is an important part, because many of the choices the MySQL ebuild will do
69# depend on this variable.
70# In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803"
71# We also strip off upstream's trailing letter that they use to respin tarballs
72
73MYSQL_VERSION_ID=""
74tpv="${PV%[a-z]}"
75tpv=( ${tpv//[-._]/ } ) ; tpv[3]="${PVR:${#PV}}" ; tpv[3]="${tpv[3]##*-r}"
76for vatom in 0 1 2 3 ; do
77 # pad to length 2
78 tpv[${vatom}]="00${tpv[${vatom}]}"
79 MYSQL_VERSION_ID="${MYSQL_VERSION_ID}${tpv[${vatom}]:0-2}"
80done
81# strip leading "0" (otherwise it's considered an octal number by BASH)
82MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"}
83
84# @ECLASS-VARIABLE: MYSQL_COMMUNITY_FEATURES
85# @DESCRIPTION:
86# Specifiy if community features are available. Possible values are 1 (yes)
87# and 0 (no).
88# Community features are available in mysql-community
89# AND in the re-merged mysql-5.0.82 and newer
90if [ "${PN}" == "mysql-community" -o "${PN}" == "mariadb" ]; then
91 MYSQL_COMMUNITY_FEATURES=1
92elif [ "${PV#5.0}" != "${PV}" ] && mysql_version_is_at_least "5.0.82"; then
93 MYSQL_COMMUNITY_FEATURES=1
94elif [ "${PV#5.1}" != "${PV}" ] && mysql_version_is_at_least "5.1.28"; then
95 MYSQL_COMMUNITY_FEATURES=1
96elif [ "${PV#5.4}" != "${PV}" ] ; then
97 MYSQL_COMMUNITY_FEATURES=1
98elif [ "${PV#5.5}" != "${PV}" ] ; then
99 MYSQL_COMMUNITY_FEATURES=1
100elif [ "${PV#6.0}" != "${PV}" ] ; then
101 MYSQL_COMMUNITY_FEATURES=1
102else
103 MYSQL_COMMUNITY_FEATURES=0
104fi
105
106# @ECLASS-VARIABLE: XTRADB_VER
107# @DESCRIPTION:
108# Version of the XTRADB storage engine
109XTRADB_VER="${XTRADB_VER}"
110
111# @ECLASS-VARIABLE: PERCONA_VER
112# @DESCRIPTION:
113# Designation by PERCONA for a MySQL version to apply an XTRADB release
114PERCONA_VER="${PERCONA_VER}"
115
116# Be warned, *DEPEND are version-dependant
117# These are used for both runtime and compiletime
118DEPEND="ssl? ( >=dev-libs/openssl-0.9.6d )
119 userland_GNU? ( sys-process/procps )
120 >=sys-apps/sed-4
121 >=sys-apps/texinfo-4.7-r1
122 >=sys-libs/readline-4.1
123 >=sys-libs/zlib-1.2.3"
124
125[[ "${PN}" == "mariadb" ]] \
126&& DEPEND="${DEPEND} libevent? ( >=dev-libs/libevent-1.4 )"
127
128# Having different flavours at the same time is not a good idea
129for i in "mysql" "mysql-community" "mariadb" ; do
130 [[ "${i}" == ${PN} ]] ||
131 DEPEND="${DEPEND} !dev-db/${i}"
132done
133
134RDEPEND="${DEPEND}
135 !minimal? ( dev-db/mysql-init-scripts )
136 selinux? ( sec-policy/selinux-mysql )"
137
138# compile-time-only
139mysql_version_is_at_least "5.1" \
140|| DEPEND="${DEPEND} berkdb? ( sys-apps/ed )"
141
142# compile-time-only
143mysql_version_is_at_least "5.1.12" \
144&& DEPEND="${DEPEND} >=dev-util/cmake-2.4.3"
145
146# dev-perl/DBD-mysql is needed by some scripts installed by MySQL
147PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )"
148
149# For other stuff to bring us in
150PDEPEND="${PDEPEND} =virtual/mysql-${MYSQL_PV_MAJOR}"
151
152# Work out the default SERVER_URI correctly
153if [ -z "${SERVER_URI}" ]; then
154 [ -z "${MY_PV}" ] && MY_PV="${PV//_/-}"
155 if [ "${PN}" == "mariadb" ]; then
156 MARIA_FULL_PV="$(replace_version_separator 3 '-' ${PV})"
157 MARIA_FULL_P="${PN}-${MARIA_FULL_PV}"
158 SERVER_URI="
159 http://ftp.rediris.es/mirror/MariaDB/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
160 http://maria.llarian.net/download/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
161 http://launchpad.net/maria/${MYSQL_PV_MAJOR}/ongoing/+download/${MARIA_FULL_P}.tar.gz
162 "
163 # The community build is on the mirrors
164 elif [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then
165 SERVER_URI="mirror://mysql/Downloads/MySQL-${PV%.*}/mysql-${MY_PV}.tar.gz"
166 # The (old) enterprise source is on the primary site only
167 elif [ "${PN}" == "mysql" ]; then
168 SERVER_URI="ftp://ftp.mysql.com/pub/mysql/src/mysql-${MY_PV}.tar.gz"
169 fi
170fi
171
172# Define correct SRC_URIs
173SRC_URI="${SERVER_URI}"
174
175# Gentoo patches to MySQL
176[[ ${MY_EXTRAS_VER} != live ]] \
177&& SRC_URI="${SRC_URI}
178 mirror://gentoo/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
179 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
180 http://dev.gentoo.org/~robbat2/distfiles/mysql-extras-${MY_EXTRAS_VER}.tar.bz2"
181
17DESCRIPTION="A fast, multi-threaded, multi-user SQL database server" 182DESCRIPTION="A fast, multi-threaded, multi-user SQL database server."
18HOMEPAGE="http://www.mysql.com/" 183HOMEPAGE="http://www.mysql.com/"
19NEWP="${PN}-${PV/_/-}" 184if [[ "${PN}" == "mariadb" ]]; then
20SRC_URI="mirror://mysql/Downloads/MySQL-${PV%.*}/${NEWP}.tar.gz 185 HOMEPAGE="http://askmonty.org/"
21 mirror://gentoo/mysql-extras-20060114.tar.bz2" 186 DESCRIPTION="MariaDB is a MySQL fork with 3rd-party patches and additional storage engines merged."
187fi
188if [[ "${PN}" == "mysql-community" ]]; then
189 DESCRIPTION="${DESCRIPTION} (obsolete, move to dev-db/mysql)"
190fi
22LICENSE="GPL-2" 191LICENSE="GPL-2"
23IUSE="big-tables berkdb debug minimal perl selinux ssl static" 192SLOT="0"
24RESTRICT="primaryuri" 193IUSE="big-tables debug embedded minimal ${IUSE_DEFAULT_ON}perl selinux ssl static test"
25DEPEND="app-admin/eselect-mysql"
26 194
195mysql_version_is_at_least "4.1" \
196&& IUSE="${IUSE} latin1"
197
27mysql_version_is_at_least "4.01.03.00" \ 198mysql_version_is_at_least "4.1.3" \
28&& IUSE="${IUSE} cluster utf8 extraengine" 199&& IUSE="${IUSE} cluster extraengine"
29 200
201mysql_version_is_at_least "5.0" \
202|| IUSE="${IUSE} raid"
203
30mysql_version_is_at_least "5.00.18.00" \ 204mysql_version_is_at_least "5.0.18" \
31&& IUSE="${IUSE} max-idx-128" 205&& IUSE="${IUSE} max-idx-128"
32 206
33mysql_version_is_at_least "5.01.00.00" \ 207mysql_version_is_at_least "5.1" \
208|| IUSE="${IUSE} berkdb"
209
210[ "${MYSQL_COMMUNITY_FEATURES}" == "1" ] \
211&& IUSE="${IUSE} ${IUSE_DEFAULT_ON}community profiling"
212
213[[ "${PN}" == "mariadb" ]] \
214&& IUSE="${IUSE} libevent"
215
216# MariaDB has integrated PBXT
217# PBXT_VERSION means that we have a PBXT patch for this PV
218# PBXT was only introduced after 5.1.12
219pbxt_patch_available() {
220 [[ "${PN}" != "mariadb" ]] \
221 && mysql_version_is_at_least "5.1.12" \
222 && [[ -n "${PBXT_VERSION}" ]]
223 return $?
224}
225
226pbxt_available() {
227 pbxt_patch_available || [[ "${PN}" == "mariadb" ]]
228 return $?
229}
230
231# Get the percona tarball if XTRADB_VER and PERCONA_VER are both set
232# MariaDB has integrated XtraDB
233# XTRADB_VERS means that we have a XTRADB patch for this PV
234# XTRADB was only introduced after 5.1.26
235xtradb_patch_available() {
236 [[ "${PN}" != "mariadb" ]] \
237 && mysql_version_is_at_least "5.1.26" \
238 && [[ -n "${XTRADB_VER}" && -n "${PERCONA_VER}" ]]
239 return $?
240}
241
242
243pbxt_patch_available \
244&& PBXT_P="pbxt-${PBXT_VERSION}" \
245&& PBXT_SRC_URI="http://www.primebase.org/download/${PBXT_P}.tar.gz mirror://sourceforge/pbxt/${PBXT_P}.tar.gz" \
246&& SRC_URI="${SRC_URI} pbxt? ( ${PBXT_SRC_URI} )" \
247
248# PBXT_NEWSTYLE means pbxt is in storage/ and gets enabled as other plugins
249# vs. built outside the dir
250pbxt_available \
251&& IUSE="${IUSE} pbxt" \
252&& mysql_version_is_at_least "5.1.40" \
253&& PBXT_NEWSTYLE=1
254
255xtradb_patch_available \
256&& XTRADB_P="percona-xtradb-${XTRADB_VER}" \
257&& XTRADB_SRC_URI_COMMON="${PERCONA_VER}/source/${XTRADB_P}.tar.gz" \
258&& XTRADB_SRC_B1="http://www.percona.com/" \
259&& XTRADB_SRC_B2="${XTRADB_SRC_B1}/percona-builds/" \
260&& XTRADB_SRC_URI1="${XTRADB_SRC_B2}/Percona-Server/Percona-Server-${XTRADB_SRC_URI_COMMON}" \
261&& XTRADB_SRC_URI2="${XTRADB_SRC_B2}/xtradb/${XTRADB_SRC_URI_COMMON}" \
262&& XTRADB_SRC_URI3="${XTRADB_SRC_B1}/${PN}/xtradb/${XTRADB_SRC_URI_COMMON}" \
263&& SRC_URI="${SRC_URI} xtradb? ( ${XTRADB_SRC_URI1} ${XTRADB_SRC_URI2} ${XTRADB_SRC_URI3} )" \
34&& IUSE="${IUSE} innodb" 264&& IUSE="${IUSE} xtradb"
35 265
36EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst pkg_postinst pkg_config pkg_postrm 266#
267# HELPER FUNCTIONS:
268#
37 269
270# @FUNCTION: mysql_disable_test
271# @DESCRIPTION:
272# Helper function to disable specific tests.
273mysql_disable_test() {
274 local rawtestname testname testsuite reason mysql_disable_file
275 rawtestname="${1}" ; shift
276 reason="${@}"
277 ewarn "test '${rawtestname}' disabled: '${reason}'"
278
279 testsuite="${rawtestname/.*}"
280 testname="${rawtestname/*.}"
281 mysql_disable_file="${S}/mysql-test/t/disabled.def"
282 #einfo "rawtestname=${rawtestname} testname=${testname} testsuite=${testsuite}"
283 echo ${testname} : ${reason} >> "${mysql_disable_file}"
284
285 # ${S}/mysql-tests/t/disabled.def
286 #
287 # ${S}/mysql-tests/suite/federated/disabled.def
288 #
289 # ${S}/mysql-tests/suite/jp/t/disabled.def
290 # ${S}/mysql-tests/suite/ndb/t/disabled.def
291 # ${S}/mysql-tests/suite/rpl/t/disabled.def
292 # ${S}/mysql-tests/suite/parts/t/disabled.def
293 # ${S}/mysql-tests/suite/rpl_ndb/t/disabled.def
294 # ${S}/mysql-tests/suite/ndb_team/t/disabled.def
295 # ${S}/mysql-tests/suite/binlog/t/disabled.def
296 # ${S}/mysql-tests/suite/innodb/t/disabled.def
297 if [ -n "${testsuite}" ]; then
298 for mysql_disable_file in \
299 ${S}/mysql-test/suite/${testsuite}/disabled.def \
300 ${S}/mysql-test/suite/${testsuite}/t/disabled.def \
301 FAILED ; do
302 [ -f "${mysql_disable_file}" ] && break
303 done
304 if [ "${mysql_disabled_file}" != "FAILED" ]; then
305 echo "${testname} : ${reason}" >> "${mysql_disable_file}"
306 else
307 ewarn "Could not find testsuite disabled.def location for ${rawtestname}"
308 fi
309 fi
310}
311
312# @FUNCTION: mysql_init_vars
313# @DESCRIPTION:
314# void mysql_init_vars()
315# Initialize global variables
316# 2005-11-19 <vivo@gentoo.org>
317mysql_init_vars() {
318 MY_SHAREDSTATEDIR=${MY_SHAREDSTATEDIR="/usr/share/mysql"}
319 MY_SYSCONFDIR=${MY_SYSCONFDIR="/etc/mysql"}
320 MY_LIBDIR=${MY_LIBDIR="/usr/$(get_libdir)/mysql"}
321 MY_LOCALSTATEDIR=${MY_LOCALSTATEDIR="/var/lib/mysql"}
322 MY_LOGDIR=${MY_LOGDIR="/var/log/mysql"}
323 MY_INCLUDEDIR=${MY_INCLUDEDIR="/usr/include/mysql"}
324
325 if [[ -z "${MY_DATADIR}" ]] ; then
326 MY_DATADIR=""
327 if [[ -f "${MY_SYSCONFDIR}/my.cnf" ]] ; then
328 MY_DATADIR=`"my_print_defaults" mysqld 2>/dev/null \
329 | sed -ne '/datadir/s|^--datadir=||p' \
330 | tail -n1`
331 if [[ -z "${MY_DATADIR}" ]] ; then
332 MY_DATADIR=`grep ^datadir "${MY_SYSCONFDIR}/my.cnf" \
333 | sed -e 's/.*=\s*//' \
334 | tail -n1`
335 fi
336 fi
337 if [[ -z "${MY_DATADIR}" ]] ; then
338 MY_DATADIR="${MY_LOCALSTATEDIR}"
339 einfo "Using default MY_DATADIR"
340 fi
341 elog "MySQL MY_DATADIR is ${MY_DATADIR}"
342
343 if [[ -z "${PREVIOUS_DATADIR}" ]] ; then
344 if [[ -e "${MY_DATADIR}" ]] ; then
345 # If you get this and you're wondering about it, see bug #207636
346 elog "MySQL datadir found in ${MY_DATADIR}"
347 elog "A new one will not be created."
348 PREVIOUS_DATADIR="yes"
349 else
350 PREVIOUS_DATADIR="no"
351 fi
352 export PREVIOUS_DATADIR
353 fi
354 else
355 if [[ ${EBUILD_PHASE} == "config" ]]; then
356 local new_MY_DATADIR
357 new_MY_DATADIR=`"my_print_defaults" mysqld 2>/dev/null \
358 | sed -ne '/datadir/s|^--datadir=||p' \
359 | tail -n1`
360
361 if [[ ( -n "${new_MY_DATADIR}" ) && ( "${new_MY_DATADIR}" != "${MY_DATADIR}" ) ]]; then
362 ewarn "MySQL MY_DATADIR has changed"
363 ewarn "from ${MY_DATADIR}"
364 ewarn "to ${new_MY_DATADIR}"
365 MY_DATADIR="${new_MY_DATADIR}"
366 fi
367 fi
368 fi
369
370 MY_SOURCEDIR=${SERVER_URI##*/}
371 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*}
372
373 export MY_SHAREDSTATEDIR MY_SYSCONFDIR
374 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR
375 export MY_INCLUDEDIR MY_DATADIR MY_SOURCEDIR
376}
377
378configure_minimal() {
379 # These are things we exclude from a minimal build, please
380 # note that the server actually does get built and installed,
381 # but we then delete it before packaging.
382 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication readline"
383
384 for i in ${minimal_exclude_list} ; do
385 myconf="${myconf} --without-${i}"
386 done
387 myconf="${myconf} --with-extra-charsets=none"
388 myconf="${myconf} --enable-local-infile"
389
390 if use static ; then
391 myconf="${myconf} --with-client-ldflags=-all-static"
392 myconf="${myconf} --disable-shared --with-pic"
393 else
394 myconf="${myconf} --enable-shared --enable-static"
395 fi
396
397 if mysql_version_is_at_least "4.1" && ! use latin1 ; then
398 myconf="${myconf} --with-charset=utf8"
399 myconf="${myconf} --with-collation=utf8_general_ci"
400 else
401 myconf="${myconf} --with-charset=latin1"
402 myconf="${myconf} --with-collation=latin1_swedish_ci"
403 fi
404}
405
406configure_common() {
407 myconf="${myconf} $(use_with big-tables)"
408 myconf="${myconf} --enable-local-infile"
409 myconf="${myconf} --with-extra-charsets=all"
410 myconf="${myconf} --with-mysqld-user=mysql"
411 myconf="${myconf} --with-server"
412 myconf="${myconf} --with-unix-socket-path=/var/run/mysqld/mysqld.sock"
413 myconf="${myconf} --without-libwrap"
414
415 if use static ; then
416 myconf="${myconf} --with-mysqld-ldflags=-all-static"
417 myconf="${myconf} --with-client-ldflags=-all-static"
418 myconf="${myconf} --disable-shared --with-pic"
419 else
420 myconf="${myconf} --enable-shared --enable-static"
421 fi
422
423 if use debug ; then
424 myconf="${myconf} --with-debug=full"
425 else
426 myconf="${myconf} --without-debug"
427 mysql_version_is_at_least "4.1.3" \
428 && use cluster \
429 && myconf="${myconf} --without-ndb-debug"
430 fi
431
432 if [ -n "${MYSQL_DEFAULT_CHARSET}" -a -n "${MYSQL_DEFAULT_COLLATION}" ]; then
433 ewarn "You are using a custom charset of ${MYSQL_DEFAULT_CHARSET}"
434 ewarn "and a collation of ${MYSQL_DEFAULT_COLLATION}."
435 ewarn "You MUST file bugs without these variables set."
436 myconf="${myconf} --with-charset=${MYSQL_DEFAULT_CHARSET}"
437 myconf="${myconf} --with-collation=${MYSQL_DEFAULT_COLLATION}"
438 elif mysql_version_is_at_least "4.1" && ! use latin1 ; then
439 myconf="${myconf} --with-charset=utf8"
440 myconf="${myconf} --with-collation=utf8_general_ci"
441 else
442 myconf="${myconf} --with-charset=latin1"
443 myconf="${myconf} --with-collation=latin1_swedish_ci"
444 fi
445
446 if use embedded ; then
447 myconf="${myconf} --with-embedded-privilege-control"
448 myconf="${myconf} --with-embedded-server"
449 else
450 myconf="${myconf} --without-embedded-privilege-control"
451 myconf="${myconf} --without-embedded-server"
452 fi
453
454}
455
456configure_40_41_50() {
457 myconf="${myconf} $(use_with perl bench)"
458 myconf="${myconf} --enable-assembler"
459 myconf="${myconf} --with-extra-tools"
460 myconf="${myconf} --with-innodb"
461 myconf="${myconf} --without-readline"
462 myconf="${myconf} $(use_with ssl openssl)"
463 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)"
464
465 # --with-vio is not needed anymore, it's on by default and
466 # has been removed from configure
467 # Apply to 4.x and 5.0.[0-3]
468 if use ssl ; then
469 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio"
470 fi
471
472 if mysql_version_is_at_least "5.0.60" ; then
473 if use berkdb ; then
474 elog "Berkeley DB support was disabled due to build failures"
475 elog "on multiple arches, go to a version earlier than 5.0.60"
476 elog "if you want it again. Gentoo bug #224067."
477 fi
478 myconf="${myconf} --without-berkeley-db"
479 elif use berkdb ; then
480 # The following fix is due to a bug with bdb on SPARC's. See:
481 # http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8
482 # It comes down to non-64-bit safety problems.
483 if use alpha || use amd64 || use hppa || use mips || use sparc ; then
484 elog "Berkeley DB support was disabled due to compatibility issues on this arch"
485 myconf="${myconf} --without-berkeley-db"
486 else
487 myconf="${myconf} --with-berkeley-db=./bdb"
488 fi
489 else
490 myconf="${myconf} --without-berkeley-db"
491 fi
492
493 if mysql_version_is_at_least "4.1.3" ; then
494 myconf="${myconf} --with-geometry"
495 myconf="${myconf} $(use_with cluster ndbcluster)"
496 fi
497
498 if mysql_version_is_at_least "4.1.3" && use extraengine ; then
499 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html
500 myconf="${myconf} --with-archive-storage-engine"
501
502 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html
503 myconf="${myconf} --with-csv-storage-engine"
504
505 # http://dev.mysql.com/doc/mysql/en/blackhole-storage-engine.html
506 myconf="${myconf} --with-blackhole-storage-engine"
507
508 # http://dev.mysql.com/doc/mysql/en/federated-storage-engine.html
509 # http://dev.mysql.com/doc/mysql/en/federated-description.html
510 # http://dev.mysql.com/doc/mysql/en/federated-limitations.html
511 if mysql_version_is_at_least "5.0.3" ; then
512 elog "Before using the Federated storage engine, please be sure to read"
513 elog "http://dev.mysql.com/doc/mysql/en/federated-limitations.html"
514 myconf="${myconf} --with-federated-storage-engine"
515 fi
516 fi
517
518 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then
519 myconf="${myconf} `use_enable community community-features`"
520 if use community; then
521 myconf="${myconf} `use_enable profiling`"
522 else
523 myconf="${myconf} --disable-profiling"
524 fi
525 fi
526
527 mysql_version_is_at_least "5.0.18" \
528 && use max-idx-128 \
529 && myconf="${myconf} --with-max-indexes=128"
530}
531
532configure_51() {
533 # TODO: !!!! readd --without-readline
534 # the failure depend upon config/ac-macros/readline.m4 checking into
535 # readline.h instead of history.h
536 myconf="${myconf} $(use_with ssl ssl /usr)"
537 myconf="${myconf} --enable-assembler"
538 myconf="${myconf} --with-geometry"
539 myconf="${myconf} --with-readline"
540 myconf="${myconf} --with-zlib-dir=/usr/"
541 myconf="${myconf} --without-pstack"
542 myconf="${myconf} --with-plugindir=/usr/$(get_libdir)/mysql/plugin"
543
544 use max-idx-128 && myconf="${myconf} --with-max-indexes=128"
545 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then
546 myconf="${myconf} $(use_enable community community-features)"
547 if use community; then
548 myconf="${myconf} $(use_enable profiling)"
549 else
550 myconf="${myconf} --disable-profiling"
551 fi
552 fi
553
554 # Scan for all available plugins
555 local plugins_avail="$(
556 LANG=C \
557 find "${S}" \
558 \( \
559 -name 'plug.in' \
560 -o -iname 'configure.in' \
561 -o -iname 'configure.ac' \
562 \) \
563 -print0 \
564 | xargs -0 sed -r -n \
565 -e '/^MYSQL_STORAGE_ENGINE/{
566 s~MYSQL_STORAGE_ENGINE\([[:space:]]*\[?([-_a-z0-9]+)\]?.*,~\1 ~g ;
567 s~^([^ ]+).*~\1~gp;
568 }' \
569 | tr -s '\n' ' '
570 )"
571
572 # 5.1 introduces a new way to manage storage engines (plugins)
573 # like configuration=none
574 # This base set are required, and will always be statically built.
575 local plugins_sta="csv myisam myisammrg heap"
576 local plugins_dyn=""
577 local plugins_dis="example ibmdb2i"
578
579 # These aren't actually required by the base set, but are really useful:
580 plugins_sta="${plugins_sta} archive blackhole"
581
582 # default in 5.5.4
583 if mysql_version_is_at_least "5.5.4" ; then
584 plugins_sta="${plugins_sta} partition"
585 fi
586 # Now the extras
587 if use extraengine ; then
588 # like configuration=max-no-ndb, archive and example removed in 5.1.11
589 # not added yet: ibmdb2i
590 # Not supporting as examples: example,daemon_example,ftexample
591 plugins_sta="${plugins_sta} partition"
592 plugins_dyn="${plugins_sta} federated"
593
594 if [[ "${PN}" != "mariadb" ]] ; then
595 elog "Before using the Federated storage engine, please be sure to read"
596 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html"
597 else
598 elog "MariaDB includes the FederatedX engine. Be sure to read"
599 elog "http://askmonty.org/wiki/index.php/Manual:FederatedX_storage_engine"
600 fi
601 else
602 plugins_dis="${plugins_dis} partition federated"
603 fi
604
605 # Upstream specifically requests that InnoDB always be built:
606 # - innobase, innodb_plugin
607 # Build falcon if available for 6.x series.
608 for i in innobase falcon ; do
609 [ -e "${S}"/storage/${i} ] && plugins_sta="${plugins_sta} ${i}"
610 done
611 for i in innodb_plugin ; do
612 [ -e "${S}"/storage/${i} ] && plugins_dyn="${plugins_dyn} ${i}"
613 done
614
615 # like configuration=max-no-ndb
616 if use cluster ; then
617 plugins_sta="${plugins_sta} ndbcluster partition"
618 plugins_dis="${plugins_dis//partition}"
619 myconf="${myconf} --with-ndb-binlog"
620 else
621 plugins_dis="${plugins_dis} ndbcluster"
622 fi
623
624 if [[ "${PN}" == "mariadb" ]] ; then
625 # In MariaDB, InnoDB is packaged in the xtradb directory, so it's not
626 # caught above.
627 plugins_sta="${plugins_sta} maria innobase"
628 myconf="${myconf} $(use_with libevent)"
629 # This is not optional, without it several upstream testcases fail.
630 # Also strongly recommended by upstream.
631 myconf="${myconf} --with-maria-tmp-tables"
632 fi
633
634 if pbxt_available && [[ "${PBXT_NEWSTYLE}" == "1" ]]; then
635 use pbxt \
636 && plugins_dyn="${plugins_dyn} pbxt" \
637 || plugins_dis="${plugins_dis} pbxt"
638 fi
639
640 use static && \
641 plugins_sta="${plugins_sta} ${plugins_dyn}" && \
642 plugins_dyn=""
643
644 einfo "Available plugins: ${plugins_avail}"
645 einfo "Dynamic plugins: ${plugins_dyn}"
646 einfo "Static plugins: ${plugins_sta}"
647 einfo "Disabled plugins: ${plugins_dis}"
648
649 # These are the static plugins
650 myconf="${myconf} --with-plugins=${plugins_sta// /,}"
651 # And the disabled ones
652 for i in ${plugins_dis} ; do
653 myconf="${myconf} --without-plugin-${i}"
654 done
655}
656
657pbxt_src_configure() {
658 mysql_init_vars
659
660 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
661
662 einfo "Reconfiguring dir '${PWD}'"
663 AT_GNUCONF_UPDATE="yes" eautoreconf
664
665 local myconf=""
666 myconf="${myconf} --with-mysql=${S} --libdir=/usr/$(get_libdir)"
667 use debug && myconf="${myconf} --with-debug=full"
668 econf ${myconf} || die "Problem configuring PBXT storage engine"
669}
670
671pbxt_src_compile() {
672
673 # Be backwards compatible for now
674 if [[ $EAPI != 2 ]]; then
675 pbxt_src_configure
676 fi
677 # TODO: is it safe/needed to use emake here ?
678 make || die "Problem making PBXT storage engine (${myconf})"
679
680 popd
681 # TODO: modify test suite for PBXT
682}
683
684pbxt_src_install() {
685 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
686 emake install DESTDIR="${D}" || die "Failed to install PBXT"
687 popd
688}
689
690#
691# EBUILD FUNCTIONS
692#
693# @FUNCTION: mysql_pkg_setup
694# @DESCRIPTION:
695# Perform some basic tests and tasks during pkg_setup phase:
696# die if FEATURES="test", USE="-minimal" and not using FEATURES="userpriv"
697# check for conflicting use flags
698# create new user and group for mysql
699# warn about deprecated features
38mysql_pkg_setup() { 700mysql_pkg_setup() {
701 if hasq test ${FEATURES} ; then
702 if ! use minimal ; then
703 if [[ $UID -eq 0 ]]; then
704 eerror "Testing with FEATURES=-userpriv is no longer supported by upstream. Tests MUST be run as non-root."
705 fi
706 fi
707 fi
39 708
709 # Check for USE flag problems in pkg_setup
710 if use static && use ssl ; then
711 M="MySQL does not support being built statically with SSL support enabled!"
712 eerror "${M}"
713 die "${M}"
714 fi
715
716 if ! mysql_version_is_at_least "5.0" \
717 && use raid \
718 && use static ; then
719 eerror "USE flags 'raid' and 'static' conflict, you cannot build MySQL statically"
720 eerror "with RAID support enabled."
721 die "USE flags 'raid' and 'static' conflict!"
722 fi
723
724 if mysql_version_is_at_least "4.1.3" \
725 && ( use cluster || use extraengine || use embedded ) \
726 && use minimal ; then
727 M="USE flags 'cluster', 'extraengine', 'embedded' conflict with 'minimal' USE flag!"
728 eerror "${M}"
729 die "${M}"
730 fi
731
732 if mysql_version_is_at_least "5.1" \
733 && xtradb_patch_available \
734 && use xtradb \
735 && use embedded ; then
736 M="USE flags 'xtradb' and 'embedded' conflict and cause build failures"
737 eerror "${M}"
738 die "${M}"
739 fi
740
741 # Bug #290570, 284946, 307251
742 # Upstream changes made us need a fairly new GCC4.
743 # But only for 5.0.8[3-6]!
744 if mysql_version_is_at_least "5.0.83" && ! mysql_version_is_at_least 5.0.87 ; then
745 GCC_VER=$(gcc-version)
746 case ${GCC_VER} in
747 2*|3*|4.0|4.1|4.2)
748 eerror "Some releases of MySQL required a very new GCC, and then"
749 eerror "later release relaxed that requirement again. Either pick a"
750 eerror "MySQL >=5.0.87, or use a newer GCC."
751 die "Active GCC too old!" ;;
752 esac
753 fi
754
755 # This should come after all of the die statements
40 enewgroup mysql 60 || die "problem adding group mysql" 756 enewgroup mysql 60 || die "problem adding 'mysql' group"
41 enewuser mysql 60 -1 /dev/null mysql \ 757 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
42 || die "problem adding user mysql"
43}
44 758
759 mysql_check_version_range "4.0 to 5.0.99.99" \
760 && use berkdb \
761 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
762
763 if [ "${PN}" != "mysql-cluster" ] && use cluster; then
764 ewarn "Upstream has noted that the NDB cluster support in the 5.0 and"
765 ewarn "5.1 series should NOT be put into production. In the near"
766 ewarn "future, it will be disabled from building."
767 ewarn ""
768 ewarn "If you need NDB support, you should instead move to the new"
769 ewarn "mysql-cluster package that represents that upstream NDB"
770 ewarn "development."
771 fi
772}
773
774# @FUNCTION: mysql_src_unpack
775# @DESCRIPTION:
776# Unpack the source code and call mysql_src_prepare for EAPI < 2.
45mysql_src_unpack() { 777mysql_src_unpack() {
46 778 # Initialize the proper variables first
47 mysql_init_vars 779 mysql_init_vars
48 780
49 if useq static && useq ssl; then
50 local msg="MySQL does not support building statically with SSL support"
51 eerror "${msg}"
52 die "${msg}"
53 fi
54
55 if mysql_version_is_at_least "4.01.03.00" \
56 && useq cluster \
57 || useq extraengine \
58 && useq minimal ; then
59 die "USEs cluster, extraengine conflicts with \"minimal\""
60 fi
61
62 unpack ${A} || die 781 unpack ${A}
782 # Grab the patches
783 [[ "${MY_EXTRAS_VER}" == "live" ]] && S="${WORKDIR}/mysql-extras" git_src_unpack
63 784
64 mv -f "${WORKDIR}/${NEWP}" "${S}" 785 mv -f "${WORKDIR}/${MY_SOURCEDIR}" "${S}"
786
787 # Be backwards compatible for now
788 case ${EAPI:-0} in
789 2) : ;;
790 0 | 1) mysql_src_prepare ;;
791 esac
792}
793
794# @FUNCTION: mysql_src_prepare
795# @DESCRIPTION:
796# Apply patches to the source code and remove unneeded bundled libs.
797mysql_src_prepare() {
65 cd "${S}" 798 cd "${S}"
66 799
800 # Apply the patches for this MySQL version
67 EPATCH_SUFFIX="patch" 801 EPATCH_SUFFIX="patch"
68 mkdir -p "${EPATCH_SOURCE}" || die "unable to create epatch directory" 802 mkdir -p "${EPATCH_SOURCE}" || die "Unable to create epatch directory"
803 # Clean out old items
804 rm -f "${EPATCH_SOURCE}"/*
805 # Now link in right patches
69 mysql_mv_patches 806 mysql_mv_patches
70 epatch || die "failed to apply all patches" 807 # And apply
808 epatch
71 809
810 # last -fPIC fixup, per bug #305873
811 i="${S}"/storage/innodb_plugin/plug.in
812 [ -f "${i}" ] && sed -i -e '/CFLAGS/s,-prefer-non-pic,,g' "${i}"
813
72 # additional check, remove bundled zlib 814 # Additional checks, remove bundled zlib
73 rm -f "${S}/zlib/"*.[ch] 815 rm -f "${S}/zlib/"*.[ch]
74 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in" 816 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in"
75 rm -f scripts/mysqlbug 817 rm -f "scripts/mysqlbug"
76
77 # Multilib issue with zlib detection
78 mysql_version_is_at_least "5.00.15.00" \
79 && sed -i -e "s:zlib_dir/lib:zlib_dir/$(get_libdir):g" \
80 "${S}/config/ac-macros/zlib.m4"
81 818
82 # Make charsets install in the right place 819 # Make charsets install in the right place
83 find . -name 'Makefile.am' \ 820 find . -name 'Makefile.am' \
84 -exec sed --in-place -e 's!$(pkgdatadir)!'${MY_SHAREDSTATEDIR}'!g' {} \; 821 -exec sed --in-place -e 's!$(pkgdatadir)!'${MY_SHAREDSTATEDIR}'!g' {} \;
85 822
86 # Manage mysqlmanager
87 mysql_version_is_at_least "5.00.15.00" \ 823 if mysql_version_is_at_least "4.1" ; then
88 && sed -i -e "s!@GENTOO_EXT@!${MY_SUFFIX}!g" \
89 -e "s!@GENTOO_SOCK_PATH@!var/run/mysqld!g" \
90 "${S}/server-tools/instance-manager/Makefile.am"
91
92 # remove what need to be recreated, so we are sure it's actually done 824 # Remove what needs to be recreated, so we're sure it's actually done
93 find . -name Makefile -o -name Makefile.in -o -name configure -exec rm -f {} \; 825 einfo "Cleaning up old buildscript files"
826 find . -name Makefile \
827 -o -name Makefile.in \
828 -o -name configure \
829 -exec rm -f {} \;
94 rm ltmain.sh 830 rm -f "ltmain.sh"
831 rm -f "scripts/mysqlbug"
832 fi
95 833
96 local rebuilddirlist d buildstep bdbdir 834 local rebuilddirlist d
97 835
836 if xtradb_patch_available && use xtradb ; then
837 einfo "Adding storage engine: Percona XtraDB (replacing InnoDB)"
838 pushd "${S}"/storage >/dev/null
839 i="innobase"
840 o="${WORKDIR}/storage-${i}.mysql-upstream"
841 # Have we been here already?
842 [ -d "${o}" ] && rm -f "${i}"
843 # Or maybe we haven't
844 [ -d "${i}" -a ! -d "${o}" ] && mv "${i}" "${o}"
845 cp -ral "${WORKDIR}/${XTRADB_P}" "${i}"
846 popd >/dev/null
847 fi
848
849 if pbxt_available && [[ "${PBXT_NEWSTYLE}" == "1" ]] && use pbxt ; then
850 einfo "Adding storage engine: PBXT"
851 pushd "${S}"/storage >/dev/null
852 i='pbxt'
853 [ -d "${i}" ] && rm -rf "${i}"
854 cp -ral "${WORKDIR}/${PBXT_P}" "${i}"
855 popd >/dev/null
856 fi
857
98 if mysql_version_is_at_least "5.01.00.00" ; then 858 if mysql_version_is_at_least "5.1.12" ; then
99 rebuilddirlist=". storage/innobase" 859 rebuilddirlist="."
100 bdbdir='storage/bdb/dist' 860 # This does not seem to be needed presently. robbat2 2010/02/23
861 #einfo "Updating innobase cmake"
862 ## TODO: check this with a cmake expert
863 #cmake \
864 # -DCMAKE_C_COMPILER=$(type -P $(tc-getCC)) \
865 # -DCMAKE_CXX_COMPILER=$(type -P $(tc-getCXX)) \
866 # "storage/innobase"
101 else 867 else
102 rebuilddirlist=". innobase" 868 rebuilddirlist=". innobase"
103 bdbdir='bdb/dist'
104 fi 869 fi
105 870
106 for d in ${rebuilddirlist}; do 871 for d in ${rebuilddirlist} ; do
107 einfo "reconfiguring dir \"${d}\"" 872 einfo "Reconfiguring dir '${d}'"
108 pushd "${d}" &>/dev/null 873 pushd "${d}" &>/dev/null
109 for buildstep in \ 874 AT_GNUCONF_UPDATE="yes" eautoreconf
110 'libtoolize --copy --force' \
111 'aclocal --force' \
112 'autoheader --force -Wnone' \
113 'autoconf --force -Wnone' \
114 'automake --force --force-missing -Wnone' \
115 'gnuconfig_update'
116 do
117 einfo "performing ${buildstep}"
118 ${buildstep} || die "failed ${buildstep/ */} dir \"${d}\""
119 done
120 popd &>/dev/null 875 popd &>/dev/null
121 done 876 done
122 877
123 if ! useq bdbdir && ! mysql_check_version_range "5.01.00.00 to 5.01.06.99" 878 if mysql_check_version_range "4.1 to 5.0.99.99" \
124 then 879 && use berkdb ; then
880 einfo "Fixing up berkdb buildsystem"
125 [[ -w "${bdbdir}/ltmain.sh" ]] && cp -f ltmain.sh "${bdbdir}/ltmain.sh" 881 [[ -w "bdb/dist/ltmain.sh" ]] && cp -f "ltmain.sh" "bdb/dist/ltmain.sh"
126 pushd "${bdbdir}" && sh s_all || die "failed bdb reconfigure" &>/dev/null 882 cp -f "/usr/share/aclocal/libtool.m4" "bdb/dist/aclocal/libtool.ac" \
883 || die "Could not copy libtool.m4 to bdb/dist/"
884 #These files exist only with libtool-2*, and need to be included.
885 if [ -f '/usr/share/aclocal/ltsugar.m4' ]; then
886 cat "/usr/share/aclocal/ltsugar.m4" >> "bdb/dist/aclocal/libtool.ac"
887 cat "/usr/share/aclocal/ltversion.m4" >> "bdb/dist/aclocal/libtool.ac"
888 cat "/usr/share/aclocal/lt~obsolete.m4" >> "bdb/dist/aclocal/libtool.ac"
889 cat "/usr/share/aclocal/ltoptions.m4" >> "bdb/dist/aclocal/libtool.ac"
890 fi
891 pushd "bdb/dist" &>/dev/null
892 sh s_all \
893 || die "Failed bdb reconfigure"
127 popd &>/dev/null 894 popd &>/dev/null
128 fi 895 fi
129
130} 896}
131 897
898# @FUNCTION: mysql_src_configure
899# @DESCRIPTION:
900# Configure mysql to build the code for Gentoo respecting the use flags.
132mysql_src_compile() { 901mysql_src_configure() {
133 902 # Make sure the vars are correctly initialized
134 mysql_init_vars 903 mysql_init_vars
904
905 # $myconf is modified by the configure_* functions
135 local myconf 906 local myconf=""
136 907
137 if useq static ; then 908 if use minimal ; then
138 myconf="${myconf} --with-mysqld-ldflags=-all-static" 909 configure_minimal
139 myconf="${myconf} --with-client-ldflags=-all-static"
140 myconf="${myconf} --disable-shared"
141 else 910 else
142 myconf="${myconf} --enable-shared --enable-static" 911 configure_common
143 fi
144
145 #myconf="${myconf} `use_with tcpd libwrap`"
146 myconf="${myconf} --without-libwrap"
147
148 if useq ssl ; then
149 # --with-vio is not needed anymore, it's on by default and
150 # has been removed from configure
151 mysql_version_is_at_least "5.00.04.00" || myconf="${myconf} --with-vio"
152 if mysql_version_is_at_least "5.00.06.00" ; then 912 if mysql_version_is_at_least "5.1.10" ; then
153 # yassl-0.96 is young break with gcc-4.0 || amd64 913 configure_51
154 #myconf="${myconf} --with-yassl"
155 myconf="${myconf} --with-openssl"
156 else 914 else
157 myconf="${myconf} --with-openssl" 915 configure_40_41_50
158 fi
159 else
160 myconf="${myconf} --without-openssl"
161 fi
162
163 if useq debug; then
164 myconf="${myconf} --with-debug=full"
165 else
166 myconf="${myconf} --without-debug"
167 mysql_version_is_at_least "4.01.03.00" && useq cluster && myconf="${myconf} --without-ndb-debug"
168 fi
169
170 # benchmarking stuff needs perl
171 # and shouldn't be bothered with on minimal builds
172 if useq perl && ! useq minimal; then
173 myconf="${myconf} --with-bench"
174 else
175 myconf="${myconf} --without-bench"
176 fi
177
178 # these are things we exclude from a minimal build
179 # note that the server actually does get built and installed
180 # but we then delete it before packaging.
181 local minimal_exclude_list="server embedded-server extra-tools innodb"
182 if ! useq minimal; then
183 for i in ${minimal_exclude_list}; do
184 myconf="${myconf} --with-${i}"
185 done
186
187 if useq static ; then
188 myconf="${myconf} --without-raid"
189 ewarn "disabling raid support, has problem with static"
190 else
191 myconf="${myconf} --with-raid"
192 fi
193
194 if ! mysql_version_is_at_least "5.00.00.00" ; then
195 if mysql_version_is_at_least "4.01.00.00" && useq utf8; then
196 myconf="${myconf} --with-charset=utf8"
197 myconf="${myconf} --with-collation=utf8_general_ci"
198 else
199 myconf="${myconf} --with-charset=latin1"
200 myconf="${myconf} --with-collation=latin1_swedish_ci"
201 fi 916 fi
202 fi 917 fi
203 918
204 # optional again from 2005-12-05
205 if mysql_version_is_at_least "5.01.00.00" ; then
206 myconf="${myconf} $(use_with innodb)"
207 else
208 myconf="${myconf} --with-innodb"
209 fi
210
211 # lots of chars
212 myconf="${myconf} --with-extra-charsets=all"
213
214 #The following fix is due to a bug with bdb on sparc's. See:
215 #http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8
216 # it comes down to non-64-bit safety problems
217 if useq sparc || useq alpha || useq hppa || useq mips || useq amd64 \
218 || mysql_check_version_range "5.01.00.00 to 5.01.06.99"
219 then
220 ewarn "bdb berkeley-db disabled due to arch or version"
221 myconf="${myconf} --without-berkeley-db"
222 else
223 useq berkdb \
224 && myconf="${myconf} --with-berkeley-db=./bdb" \
225 || myconf="${myconf} --without-berkeley-db"
226 fi
227
228 if mysql_version_is_at_least "4.01.03.00" ; then
229 #myconf="${myconf} $(use_with geometry)"
230 myconf="${myconf} --with-geometry"
231 myconf="${myconf} $(use_with cluster ndbcluster)"
232 fi
233
234 mysql_version_is_at_least "4.01.11.00" && myconf="${myconf} `use_with big-tables`"
235 else
236 for i in ${minimal_exclude_list}; do
237 myconf="${myconf} --without-${i}"
238 done
239 myconf="${myconf} --without-berkeley-db"
240 myconf="${myconf} --with-extra-charsets=none"
241 fi
242
243 if mysql_version_is_at_least "4.01.03.00" && useq extraengine; then
244 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html
245 myconf="${myconf} --with-archive-storage-engine"
246 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html
247
248 mysql_version_is_at_least "4.01.04.00" \
249 && myconf="${myconf} --with-csv-storage-engine"
250
251 mysql_version_is_at_least "4.01.11.00" \
252 && myconf="${myconf} --with-blackhole-storage-engine"
253
254 # http://dev.mysql.com/doc/mysql/en/federated-description.html
255 # http://dev.mysql.com/doc/mysql/en/federated-limitations.html
256 if mysql_version_is_at_least "5.00.03.00" ; then
257 einfo "before to use federated engine be sure to read"
258 einfo "http://dev.mysql.com/doc/refman/5.0/en/federated-limitations.html"
259 myconf="${myconf} --with-federated-storage-engine"
260
261 # http://dev.mysql.com/doc/refman/5.1/en/partitioning-overview.html
262 if mysql_version_is_at_least "5.01.00.00" ; then
263 myconf="${myconf} --with-partition"
264 fi
265 fi
266
267 mysql_version_is_at_least "5.00.18.00" \
268 && useq "max-idx-128" \
269 && myconf="${myconf} --with-max-indexes=128"
270 fi
271
272 #Bug #114895,Bug #110149 919 # Bug #114895, bug #110149
273 filter-flags "-O" "-O[01]" 920 filter-flags "-O" "-O[01]"
921
274 #glibc-2.3.2_pre fix; bug #16496 922 # glib-2.3.2_pre fix, bug #16496
275 append-flags "-DHAVE_ERRNO_AS_DEFINE=1" 923 append-flags "-DHAVE_ERRNO_AS_DEFINE=1"
276 924
277 #the compiler flags are as per their "official" spec ;) 925 # As discovered by bug #246652, doing a double-level of SSP causes NDB to
278 #CFLAGS="${CFLAGS/-O?/} -O3" \ 926 # fail badly during cluster startup.
927 if [[ $(gcc-major-version) -lt 4 ]]; then
928 filter-flags "-fstack-protector-all"
929 fi
930
931 CXXFLAGS="${CXXFLAGS} -fno-exceptions -fno-strict-aliasing"
279 export CXXFLAGS="${CXXFLAGS} -felide-constructors -fno-exceptions -fno-rtti" 932 CXXFLAGS="${CXXFLAGS} -felide-constructors -fno-rtti"
280 mysql_version_is_at_least "5.00.00.00" \ 933 mysql_version_is_at_least "5.0" \
281 && export CXXFLAGS="${CXXFLAGS} -fno-implicit-templates" 934 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates"
935 export CXXFLAGS
936
937 # bug #283926, with GCC4.4, this is required to get correct behavior.
938 append-flags -fno-strict-aliasing
282 939
283 econf \ 940 econf \
284 --program-suffix="${MY_SUFFIX}" \
285 --libexecdir="/usr/sbin" \ 941 --libexecdir="/usr/sbin" \
286 --sysconfdir="${MY_SYSCONFDIR}" \ 942 --sysconfdir="${MY_SYSCONFDIR}" \
287 --localstatedir="${MY_LOCALSTATEDIR}" \ 943 --localstatedir="${MY_LOCALSTATEDIR}" \
288 --sharedstatedir="${MY_SHAREDSTATEDIR}" \ 944 --sharedstatedir="${MY_SHAREDSTATEDIR}" \
289 --libdir="${MY_LIBDIR}" \ 945 --libdir="${MY_LIBDIR}" \
290 --includedir="${MY_INCLUDEDIR}" \ 946 --includedir="${MY_INCLUDEDIR}" \
291 --with-low-memory \ 947 --with-low-memory \
292 --enable-assembler \
293 --enable-local-infile \
294 --with-mysqld-user=mysql \
295 --with-client-ldflags=-lstdc++ \ 948 --with-client-ldflags=-lstdc++ \
296 --enable-thread-safe-client \ 949 --enable-thread-safe-client \
297 --with-comment="Gentoo Linux ${PF}" \ 950 --with-comment="Gentoo Linux ${PF}" \
298 --with-unix-socket-path="/var/run/mysqld/mysqld${MY_SUFFIX}.sock" \
299 --with-zlib-dir=/usr \
300 --with-lib-ccflags="-fPIC" \
301 --without-readline \
302 --without-docs \ 951 --without-docs \
303 ${myconf} || die "bad ./configure" 952 ${myconf} || die "econf failed"
304 953
305 # TODO Move this before autoreconf !!! 954 # TODO: Move this before autoreconf !!!
306 find . -name 'Makefile' \ 955 find . -type f -name Makefile -print0 \
307 -exec sed --in-place \ 956 | xargs -0 -n100 sed -i \
308 -e 's|^pkglibdir\s*=\s*$(libdir)/mysql|pkglibdir = $(libdir)|' \ 957 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|'
309 -e 's|^pkgincludedir\s*=\s*$(includedir)/mysql|pkgincludedir = $(includedir)|' \
310 {} \;
311 958
312 emake || die "compile problem" 959 if [[ $EAPI == 2 ]] && [[ "${PBXT_NEWSTYLE}" != "1" ]]; then
960 pbxt_patch_available && use pbxt && pbxt_src_configure
961 fi
313} 962}
314 963
964# @FUNCTION: mysql_src_compile
965# @DESCRIPTION:
966# Compile the mysql code.
967mysql_src_compile() {
968 # Be backwards compatible for now
969 case ${EAPI:-0} in
970 2) : ;;
971 0 | 1) mysql_src_configure ;;
972 esac
973
974 emake || die "emake failed"
975
976 if [[ "${PBXT_NEWSTYLE}" != "1" ]]; then
977 pbxt_patch_available && use pbxt && pbxt_src_compile
978 fi
979}
980
981# @FUNCTION: mysql_src_install
982# @DESCRIPTION:
983# Install mysql.
315mysql_src_install() { 984mysql_src_install() {
316 985 # Make sure the vars are correctly initialized
317 mysql_init_vars 986 mysql_init_vars
318 make install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die
319 987
320 insinto "${MY_INCLUDEDIR}" 988 emake install \
321 doins "${MY_INCLUDEDIR}"/my_{config,dir}.h 989 DESTDIR="${D}" \
990 benchdir_root="${MY_SHAREDSTATEDIR}" \
991 testroot="${MY_SHAREDSTATEDIR}" \
992 || die "emake install failed"
322 993
994 if [[ "${PBXT_NEWSTYLE}" != "1" ]]; then
995 pbxt_patch_available && use pbxt && pbxt_src_install
996 fi
997
323 # convenience links 998 # Convenience links
999 einfo "Making Convenience links for mysqlcheck multi-call binary"
324 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqlanalyze${MY_SUFFIX}" 1000 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze"
325 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqlrepair${MY_SUFFIX}" 1001 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair"
326 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqloptimize${MY_SUFFIX}" 1002 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqloptimize"
327 1003
328 # various junk (my-*.cnf moved elsewhere) 1004 # Various junk (my-*.cnf moved elsewhere)
1005 einfo "Removing duplicate /usr/share/mysql files"
329 rm -rf "${D}/usr/share/info" 1006 rm -Rf "${D}/usr/share/info"
330 for removeme in "mysql-log-rotate" mysql.server* \ 1007 for removeme in "mysql-log-rotate" mysql.server* \
331 binary-configure* my-*.cnf mi_test_all* 1008 binary-configure* my-*.cnf mi_test_all*
332 do 1009 do
333 rm -f ${D}/usr/share/mysql/${removeme} 1010 rm -f "${D}"/${MY_SHAREDSTATEDIR}/${removeme}
334 done 1011 done
335 1012
336 # TODO change at Makefile-am level
337 for moveme in "mysql_fix_privilege_tables.sql" \
338 "fill_help_tables.sql" "ndb-config-2-node.ini"
339 do
340 mv -f "${D}/usr/share/mysql/${moveme}" "${D}/usr/share/mysql${MY_SUFFIX}/" 2>/dev/null
341 done
342
343 if [[ -n "${MY_SUFFIX}" ]] ; then
344 local notcatched=$(ls "${D}/usr/share/mysql"/*)
345 if [[ -n "${notcatched}" ]] ; then
346 ewarn "QA notice"
347 ewarn "${notcatched} files in /usr/share/mysql"
348 ewarn "bug mysql-herd to manage them"
349 fi
350 rm -rf "${D}/usr/share/mysql"
351 fi
352
353 # clean up stuff for a minimal build 1013 # Clean up stuff for a minimal build
354 # this is anything server-specific
355 if useq minimal; then 1014 if use minimal ; then
1015 einfo "Remove all extra content for minimal build"
356 rm -rf ${D}${MY_SHAREDSTATEDIR}/{mysql-test,sql-bench} 1016 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench}
357 rm -f ${D}/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam} 1017 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam}
358 rm -f "${D}/usr/sbin/mysqld${MY_SUFFIX}" 1018 rm -f "${D}/usr/sbin/mysqld"
359 rm -f ${D}${MY_LIBDIR}/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a 1019 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a
360 fi 1020 fi
361 1021
1022 # Unless they explicitly specific USE=test, then do not install the
1023 # testsuite. It DOES have a use to be installed, esp. when you want to do a
1024 # validation of your database configuration after tuning it.
1025 if use !test ; then
1026 rm -rf "${D}"/${MY_SHAREDSTATEDIR}/mysql-test
1027 fi
1028
362 # config stuff 1029 # Configuration stuff
1030 if mysql_version_is_at_least "5.1" ; then
1031 mysql_mycnf_version="5.1"
1032 elif mysql_version_is_at_least "4.1" ; then
1033 mysql_mycnf_version="4.1"
1034 else
1035 mysql_mycnf_version="4.0"
1036 fi
1037 einfo "Building default my.cnf"
363 insinto "${MY_SYSCONFDIR}" 1038 insinto "${MY_SYSCONFDIR}"
364 doins scripts/mysqlaccess.conf 1039 doins scripts/mysqlaccess.conf
1040 sed -e "s!@DATADIR@!${MY_DATADIR}!g" \
1041 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \
1042 > "${TMPDIR}/my.cnf.ok"
1043 if mysql_version_is_at_least "4.1" && use latin1 ; then
1044 sed -i \
1045 -e "/character-set/s|utf8|latin1|g" \
1046 "${TMPDIR}/my.cnf.ok"
1047 fi
365 newins "${FILESDIR}/my.cnf-4.1" my.cnf 1048 newins "${TMPDIR}/my.cnf.ok" my.cnf
366 insinto "/etc/conf.d"
367 newins "${FILESDIR}/mysql-slot.conf.d-r2" "mysql"
368 mysql_version_is_at_least "5.00.11.00" \
369 && newins "${FILESDIR}/mysqlmanager-slot.conf.d" "mysqlmanager"
370 1049
371 local charset='utf8'
372 ! useq utf8 && local charset='latin1'
373 sed --in-place \
374 -e "s/@MY_SUFFIX@/${MY_SUFFIX}/" \
375 -e "s/@CHARSET@/${charset}/" \
376 "${D}/etc/mysql${MY_SUFFIX}/my.cnf"
377
378 # minimal builds don't have the server 1050 # Minimal builds don't have the MySQL server
379 if ! useq minimal; then 1051 if ! use minimal ; then
380 exeinto /etc/init.d 1052 einfo "Creating initial directories"
381 newexe "${FILESDIR}/mysql-slot.rc6-r2" "mysql" 1053 # Empty directories ...
382 [[ ${SLOT} -gt 0 ]] && dosym "/etc/init.d/mysql" "/etc/init.d/mysql${MY_SUFFIX}"
383
384 mysql_version_is_at_least "5.00.11.00" \
385 && newexe "${FILESDIR}/mysqlmanager-slot.rc6" "mysqlmanager"
386 insinto /etc/logrotate.d
387 # TODO
388 newins "${FILESDIR}/logrotate.mysql" "mysql${MY_SUFFIX}"
389
390 #empty dirs...
391 diropts "-m0750" 1054 diropts "-m0750"
392 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then 1055 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then
393 dodir "${DATADIR}" 1056 dodir "${MY_DATADIR}"
394 keepdir "${DATADIR}" 1057 keepdir "${MY_DATADIR}"
395 chown -R mysql:mysql "${D}/${DATADIR}" 1058 chown -R mysql:mysql "${D}/${MY_DATADIR}"
396 fi 1059 fi
397 1060
398 diropts "-m0755" 1061 diropts "-m0755"
399 for folder in "${MY_LOGDIR}" "/var/run/mysqld" ; do 1062 for folder in "${MY_LOGDIR}" "/var/run/mysqld" ; do
400 dodir "${folder}" 1063 dodir "${folder}"
401 keepdir "${folder}" 1064 keepdir "${folder}"
402 chown -R mysql:mysql "${D}/${folder}" 1065 chown -R mysql:mysql "${D}/${folder}"
403 done 1066 done
404 fi 1067 fi
405 1068
406 # docs 1069 # Docs
1070 einfo "Installing docs"
407 dodoc README COPYING ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE 1071 dodoc README ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE
1072 doinfo "${S}"/Docs/mysql.info
1073
408 # minimal builds don't have the server 1074 # Minimal builds don't have the MySQL server
409 if ! useq minimal; then 1075 if ! use minimal ; then
1076 einfo "Including support files and sample configurations"
1077 docinto "support-files"
1078 for script in \
1079 "${S}"/support-files/my-*.cnf \
1080 "${S}"/support-files/magic \
1081 "${S}"/support-files/ndb-config-2-node.ini
1082 do
1083 [[ -f "$script" ]] && dodoc "${script}"
1084 done
1085
1086 docinto "scripts"
1087 for script in "${S}"/scripts/mysql* ; do
1088 [[ -f "$script" ]] && [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
1089 done
1090
1091 fi
1092
1093 mysql_lib_symlinks "${D}"
1094}
1095
1096# @FUNCTION: mysql_pkg_preinst
1097# @DESCRIPTION:
1098# Create the user and groups for mysql - die if that fails.
1099mysql_pkg_preinst() {
1100 enewgroup mysql 60 || die "problem adding 'mysql' group"
1101 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
1102}
1103
1104# @FUNCTION: mysql_pkg_postinst
1105# @DESCRIPTION:
1106# Run post-installation tasks:
1107# create the dir for logfiles if non-existant
1108# touch the logfiles and secure them
1109# install scripts
1110# issue required steps for optional features
1111# issue deprecation warnings
1112mysql_pkg_postinst() {
1113 # Make sure the vars are correctly initialized
1114 mysql_init_vars
1115
1116 # Check FEATURES="collision-protect" before removing this
1117 [[ -d "${ROOT}/var/log/mysql" ]] || install -d -m0750 -o mysql -g mysql "${ROOT}${MY_LOGDIR}"
1118
1119 # Secure the logfiles
1120 touch "${ROOT}${MY_LOGDIR}"/mysql.{log,err}
1121 chown mysql:mysql "${ROOT}${MY_LOGDIR}"/mysql*
1122 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql*
1123
1124 # Minimal builds don't have the MySQL server
1125 if ! use minimal ; then
410 docinto "support-files" 1126 docinto "support-files"
411 for script in \ 1127 for script in \
412 support-files/my-*.cnf \ 1128 support-files/my-*.cnf \
413 support-files/magic \ 1129 support-files/magic \
414 support-files/ndb-config-2-node.ini 1130 support-files/ndb-config-2-node.ini
415 do 1131 do
1132 [[ -f "${script}" ]] \
416 dodoc "${script}" 1133 && dodoc "${script}"
417 done 1134 done
418 1135
419 docinto "scripts" 1136 docinto "scripts"
420 for script in scripts/mysql* ; do 1137 for script in scripts/mysql* ; do
1138 [[ -f "${script}" ]] \
421 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}" 1139 && [[ "${script%.sh}" == "${script}" ]] \
1140 && dodoc "${script}"
422 done 1141 done
423 fi
424 1142
425 # oops, temporary fix 1143 einfo
426 mysql_check_version_range "5.00.16.00 to 5.00.18.99" \ 1144 elog "You might want to run:"
427 && cp -f \ 1145 elog "\"emerge --config =${CATEGORY}/${PF}\""
428 "${WORKDIR}/mysql-extras/fill_help_tables.sql-5.0" \ 1146 elog "if this is a new install."
429 "${D}/usr/share/mysql${MY_SUFFIX}/fill_help_tables.sql" 1147 einfo
430} 1148 fi
431 1149
432mysql_pkg_preinst() { 1150 if pbxt_available && use pbxt ; then
1151 # TODO: explain it better
1152 elog " mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';"
1153 elog " mysql> CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;"
1154 elog "if, after that, you cannot start the MySQL server,"
1155 elog "remove the ${MY_DATADIR}/mysql/plugin.* files, then"
1156 elog "use the MySQL upgrade script to restore the table"
1157 elog "or execute the following SQL command:"
1158 elog " CREATE TABLE IF NOT EXISTS plugin ("
1159 elog " name char(64) binary DEFAULT '' NOT NULL,"
1160 elog " dl char(128) DEFAULT '' NOT NULL,"
1161 elog " PRIMARY KEY (name)"
1162 elog " ) CHARACTER SET utf8 COLLATE utf8_bin;"
1163 fi
433 1164
434 enewgroup mysql 60 || die "problem adding group mysql" 1165 mysql_check_version_range "4.0 to 5.0.99.99" \
435 enewuser mysql 60 -1 /dev/null mysql \ 1166 && use berkdb \
436 || die "problem adding user mysql" 1167 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
437} 1168}
438 1169
1170# @FUNCTION: mysql_pkg_config
1171# @DESCRIPTION:
1172# Configure mysql environment.
439mysql_pkg_postinst() { 1173mysql_pkg_config() {
1174 local old_MY_DATADIR="${MY_DATADIR}"
440 1175
1176 # Make sure the vars are correctly initialized
441 mysql_init_vars 1177 mysql_init_vars
442 mysql_lib_symlinks
443 1178
444 # mind at FEATURES=collision-protect before to remove this 1179 [[ -z "${MY_DATADIR}" ]] && die "Sorry, unable to find MY_DATADIR"
445 [ -d "${ROOT}/var/log/mysql" ] \
446 || install -d -m0750 -o mysql -g mysql "${ROOT}${MY_LOGDIR}"
447 1180
448 #secure the logfiles... does this bother anybody? 1181 if built_with_use ${CATEGORY}/${PN} minimal ; then
449 touch "${ROOT}${MY_LOGDIR}"/mysql.{log,err} 1182 die "Minimal builds do NOT include the MySQL server"
450 chown mysql:mysql "${ROOT}${MY_LOGDIR}"/mysql* 1183 fi
451 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql*
452 1184
453 # create a list of files, to be used 1185 if [[ ( -n "${MY_DATADIR}" ) && ( "${MY_DATADIR}" != "${old_MY_DATADIR}" ) ]]; then
454 # by external utilities 1186 local MY_DATADIR_s="$(strip_duplicate_slashes ${ROOT}/${MY_DATADIR})"
455 # uncompressed because of the small size 1187 local old_MY_DATADIR_s="$(strip_duplicate_slashes ${ROOT}/${old_MY_DATADIR})"
456 local filelist="${ROOT}/var/lib/eselect/mysql/mysql${MY_SUFFIX}"
457 pushd "${D}/" &>/dev/null
458 mkdir -p "${ROOT}/var/lib/eselect/mysql/"
459 env -i find usr/bin/ usr/sbin/ usr/share/man \
460 -type f -name "*${MY_SUFFIX}*" \
461 -and -not -name "mysql_config${MY_SUFFIX}" \
462 > "${filelist}.filelist"
463 echo "${MY_SYSCONFDIR#"/"}" >> "${filelist}.filelist"
464 echo "${MY_LIBDIR#"/"}" >> "${filelist}.filelist"
465 echo "${MY_SHAREDSTATEDIR#"/"}" >> "${filelist}.filelist"
466 popd &>/dev/null
467 1188
468 if ! useq minimal; then 1189 if [[ -d "${old_MY_DATADIR_s}" ]]; then
469 if [[ ${SLOT} -gt 0 ]] ; then 1190 if [[ -d "${MY_DATADIR_s}" ]]; then
470 if [[ -f "${ROOT}/usr/sbin/mysqld" ]] ; then 1191 ewarn "Both ${old_MY_DATADIR_s} and ${MY_DATADIR_s} exist"
471 einfo "you may want to run unmerge any unslotted MySQL versions with " 1192 ewarn "Attempting to use ${MY_DATADIR_s} and preserving ${old_MY_DATADIR_s}"
472 einfo "emerge -C --pretend dev-db/mysql"
473 einfo "emerge -C =dev-db/mysql-X.Y.Z"
474 einfo "After the unmerge run \"eselect myqsl list\" followed by a "
475 einfo "\"eselect myqsl set 1\" to chose the default mysql server"
476 else 1193 else
477 local tmpres="$( eselect mysql show )" 1194 elog "Moving MY_DATADIR from ${old_MY_DATADIR_s} to ${MY_DATADIR_s}"
478 # "like grep -q unset" 1195 mv --strip-trailing-slashes -T "${old_MY_DATADIR_s}" "${MY_DATADIR_s}" \
479 if [[ "{$tmpres}" == "{$tmpres/unset/}" ]] ; then 1196 || die "Moving MY_DATADIR failed"
480 eselect mysql set 1
481 else
482 einfo "The version of mysql emerged now stils is _NOT_ the default"
483 einfo "you may want to run \"eselect myqsl list\" followed by a "
484 einfo "\"eselect myqsl set 1\" to chose the default mysql server"
485 fi
486 fi 1197 fi
1198 else
1199 ewarn "Previous MY_DATADIR (${old_MY_DATADIR_s}) does not exist"
1200 if [[ -d "${MY_DATADIR_s}" ]]; then
1201 ewarn "Attempting to use ${MY_DATADIR_s}"
1202 else
1203 eerror "New MY_DATADIR (${MY_DATADIR_s}) does not exist"
1204 die "Configuration Failed! Please reinstall ${CATEGORY}/${PN}"
487 fi 1205 fi
488
489 # your friendly public service announcement...
490 einfo
491 einfo "You might want to run:"
492 einfo "\"emerge --config =${CATEGORY}/${PF}\""
493 einfo "if this is a new install."
494 einfo
495 einfo "InnoDB is not optional as of MySQL-4.0.24, at the request of upstream."
496 fi 1206 fi
497}
498
499mysql_pkg_config() {
500 mysql_init_vars
501 [[ -z "${DATADIR}" ]] && die "sorry, unable to find DATADIR"
502
503 if built_with_use dev-db/mysql minimal; then
504 die "Minimal builds do NOT include the MySQL server"
505 fi 1207 fi
506 1208
507 local pwd1="a" 1209 local pwd1="a"
508 local pwd2="b" 1210 local pwd2="b"
1211 local MYSQL_ROOT_PASSWORD=''
509 local maxtry=5 1212 local maxtry=15
510 1213
1214 if [ -z "${MYSQL_ROOT_PASSWORD}" -a -f "${ROOT}/root/.my.cnf" ]; then
1215 MYSQL_ROOT_PASSWORD="$(sed -n -e '/^password=/s,^password=,,gp' "${ROOT}/root/.my.cnf")"
1216 fi
1217
511 if [[ -d "${ROOT}/${DATADIR}/mysql" ]] ; then 1218 if [[ -d "${ROOT}/${MY_DATADIR}/mysql" ]] ; then
512 ewarn "You have already a MySQL database in place." 1219 ewarn "You have already a MySQL database in place."
513 ewarn "(${ROOT}/${DATADIR}/*)" 1220 ewarn "(${ROOT}/${MY_DATADIR}/*)"
514 ewarn "Please rename or delete it if you wish to replace it." 1221 ewarn "Please rename or delete it if you wish to replace it."
515 die "MySQL database already exists!" 1222 die "MySQL database already exists!"
516 fi 1223 fi
517 1224
518 einfo "Creating the mysql database and setting proper" 1225 # Bug #213475 - MySQL _will_ object strenously if your machine is named
519 einfo "permissions on it..." 1226 # localhost. Also causes weird failures.
1227 [[ "${HOSTNAME}" == "localhost" ]] && die "Your machine must NOT be named localhost"
520 1228
1229 if [ -z "${MYSQL_ROOT_PASSWORD}" ]; then
1230
521 einfo "Insert a password for the mysql 'root' user" 1231 einfo "Please provide a password for the mysql 'root' user now,"
1232 einfo "or in the MYSQL_ROOT_PASSWORD env var."
522 ewarn "Avoid [\"'\\_%] characters in the password" 1233 ewarn "Avoid [\"'\\_%] characters in the password"
523
524 read -rsp " >" pwd1 ; echo 1234 read -rsp " >" pwd1 ; echo
1235
525 einfo "Check the password" 1236 einfo "Retype the password"
526 read -rsp " >" pwd2 ; echo 1237 read -rsp " >" pwd2 ; echo
527 1238
528 if [[ "x$pwd1" != "x$pwd2" ]] ; then 1239 if [[ "x$pwd1" != "x$pwd2" ]] ; then
529 die "Passwords are not the same" 1240 die "Passwords are not the same"
1241 fi
1242 MYSQL_ROOT_PASSWORD="${pwd1}"
1243 unset pwd1 pwd2
530 fi 1244 fi
531 1245
532 local options="" 1246 local options=""
533 local sqltmp="$(emktemp)" 1247 local sqltmp="$(emktemp)"
534 1248
535 local help_tables="${ROOT}/usr/share/doc/mysql-${PVR}/scripts/fill_help_tables.sql.gz" 1249 local help_tables="${ROOT}${MY_SHAREDSTATEDIR}/fill_help_tables.sql"
536 [[ -r "${help_tables}" ]] \ 1250 [[ -r "${help_tables}" ]] \
537 && zcat "${help_tables}" > "${TMPDIR}/fill_help_tables.sql" \ 1251 && cp "${help_tables}" "${TMPDIR}/fill_help_tables.sql" \
538 || touch "${TMPDIR}/fill_help_tables.sql" 1252 || touch "${TMPDIR}/fill_help_tables.sql"
539 help_tables="${TMPDIR}/fill_help_tables.sql" 1253 help_tables="${TMPDIR}/fill_help_tables.sql"
540 1254
541 pushd "${TMPDIR}" &>/dev/null 1255 pushd "${TMPDIR}" &>/dev/null
542 ${ROOT}/usr/bin/mysql_install_db${MY_SUFFIX} | grep -B5 -A999 -i "ERROR" 1256 "${ROOT}/usr/bin/mysql_install_db" >"${TMPDIR}"/mysql_install_db.log 2>&1
1257 if [ $? -ne 0 ]; then
1258 grep -B5 -A999 -i "ERROR" "${TMPDIR}"/mysql_install_db.log 1>&2
1259 die "Failed to run mysql_install_db. Please review /var/log/mysql/mysqld.err AND ${TMPDIR}/mysql_install_db.log"
1260 fi
543 popd &>/dev/null 1261 popd &>/dev/null
544 [[ -f ${ROOT}/${DATADIR}/mysql/user.frm ]] || die "MySQL databases not installed" 1262 [[ -f "${ROOT}/${MY_DATADIR}/mysql/user.frm" ]] \
1263 || die "MySQL databases not installed"
545 chown -R mysql:mysql ${ROOT}/${DATADIR} 2> /dev/null 1264 chown -R mysql:mysql "${ROOT}/${MY_DATADIR}" 2>/dev/null
546 chmod 0750 ${ROOT}/${DATADIR} 2> /dev/null 1265 chmod 0750 "${ROOT}/${MY_DATADIR}" 2>/dev/null
547 1266
1267 # Figure out which options we need to disable to do the setup
1268 helpfile="${TMPDIR}/mysqld-help"
1269 ${ROOT}/usr/sbin/mysqld --verbose --help >"${helpfile}" 2>/dev/null
1270 for opt in grant-tables host-cache name-resolve networking slave-start bdb \
1271 federated innodb ssl log-bin relay-log slow-query-log external-locking \
1272 ; do
1273 optexp="--(skip-)?${opt}" optfull="--skip-${opt}"
1274 egrep -sq -- "${optexp}" "${helpfile}" && options="${options} ${optfull}"
1275 done
1276 # But some options changed names
1277 egrep -sq external-locking "${helpfile}" && \
1278 options="${options/skip-locking/skip-external-locking}"
1279
548 if mysql_version_is_at_least "4.01.03.00" ; then 1280 if mysql_version_is_at_least "4.1.3" ; then
549 options="--skip-ndbcluster"
550
551 # Filling timezones, see 1281 # Filling timezones, see
552 # http://dev.mysql.com/doc/mysql/en/time-zone-support.html 1282 # http://dev.mysql.com/doc/mysql/en/time-zone-support.html
553 ${ROOT}/usr/bin/mysql_tzinfo_to_sql${MY_SUFFIX} ${ROOT}/usr/share/zoneinfo \ 1283 "${ROOT}/usr/bin/mysql_tzinfo_to_sql" "${ROOT}/usr/share/zoneinfo" > "${sqltmp}" 2>/dev/null
554 > "${sqltmp}" 2>/dev/null
555 1284
556 if [[ -r "${help_tables}" ]] ; then 1285 if [[ -r "${help_tables}" ]] ; then
557 cat "${help_tables}" >> "${sqltmp}" 1286 cat "${help_tables}" >> "${sqltmp}"
558 fi 1287 fi
559 fi 1288 fi
1289
1290 einfo "Creating the mysql database and setting proper"
1291 einfo "permissions on it ..."
560 1292
561 local socket=${ROOT}/var/run/mysqld/mysqld${MY_SUFFIX}${RANDOM}.sock 1293 local socket="${ROOT}/var/run/mysqld/mysqld${RANDOM}.sock"
562 local pidfile=${ROOT}/var/run/mysqld/mysqld${MY_SUFFIX}${RANDOM}.sock 1294 local pidfile="${ROOT}/var/run/mysqld/mysqld${RANDOM}.pid"
563 local mysqld="${ROOT}/usr/sbin/mysqld${MY_SUFFIX} \ 1295 local mysqld="${ROOT}/usr/sbin/mysqld \
564 ${options} \ 1296 ${options} \
565 --user=mysql \ 1297 --user=mysql \
566 --skip-grant-tables \
567 --basedir=${ROOT}/usr \ 1298 --basedir=${ROOT}/usr \
568 --datadir=${ROOT}/${DATADIR} \ 1299 --datadir=${ROOT}/${MY_DATADIR} \
569 --skip-innodb \
570 --skip-bdb \
571 --skip-networking \
572 --max_allowed_packet=8M \ 1300 --max_allowed_packet=8M \
573 --net_buffer_length=16K \ 1301 --net_buffer_length=16K \
1302 --default-storage-engine=MyISAM \
574 --socket=${socket} \ 1303 --socket=${socket} \
575 --pid-file=${pidfile}" 1304 --pid-file=${pidfile}"
1305 #einfo "About to start mysqld: ${mysqld}"
1306 ebegin "Starting mysqld"
576 $mysqld & 1307 ${mysqld} &
1308 rc=$?
577 while ! [[ -S "${socket}" || "${maxtry}" -lt 1 ]] ; do 1309 while ! [[ -S "${socket}" || "${maxtry}" -lt 1 ]] ; do
578 maxtry=$(($maxtry-1)) 1310 maxtry=$((${maxtry}-1))
579 echo -n "." 1311 echo -n "."
580 sleep 1 1312 sleep 1
581 done 1313 done
1314 eend $rc
582 1315
1316 if ! [[ -S "${socket}" ]]; then
1317 die "Completely failed to start up mysqld with: ${mysqld}"
1318 fi
1319
1320 ebegin "Setting root password"
583 # do this from memory we don't want clear text password in temp files 1321 # Do this from memory, as we don't want clear text passwords in temp files
584 local sql="UPDATE mysql.user SET Password = PASSWORD('${pwd1}') WHERE USER='root'" 1322 local sql="UPDATE mysql.user SET Password = PASSWORD('${MYSQL_ROOT_PASSWORD}') WHERE USER='root'"
585 ${ROOT}/usr/bin/mysql${MY_SUFFIX} \ 1323 "${ROOT}/usr/bin/mysql" \
586 --socket=${socket} \ 1324 --socket=${socket} \
587 -hlocalhost \ 1325 -hlocalhost \
588 -e "${sql}" 1326 -e "${sql}"
1327 eend $?
589 1328
590 einfo "Loading \"zoneinfo\" this step may require few seconds" 1329 ebegin "Loading \"zoneinfo\", this step may require a few seconds ..."
591
592 ${ROOT}/usr/bin/mysql${MY_SUFFIX} \ 1330 "${ROOT}/usr/bin/mysql" \
593 --socket=${socket} \ 1331 --socket=${socket} \
594 -hlocalhost \ 1332 -hlocalhost \
595 -uroot \ 1333 -uroot \
596 -p"${pwd1}" \ 1334 -p"${MYSQL_ROOT_PASSWORD}" \
597 mysql < "${sqltmp}" 1335 mysql < "${sqltmp}"
1336 rc=$?
1337 eend $?
1338 [ $rc -ne 0 ] && ewarn "Failed to load zoneinfo!"
598 1339
599 # server stop and cleanup 1340 # Stop the server and cleanup
1341 einfo "Stopping the server ..."
600 kill $(< "${pidfile}" ) 1342 kill $(< "${pidfile}" )
601 rm "${sqltmp}" 1343 rm -f "${sqltmp}"
602 einfo "stopping the server,"
603 wait %1 1344 wait %1
604 einfo "done" 1345 einfo "Done"
605} 1346}
606 1347
1348# @FUNCTION: mysql_pkg_postrm
1349# @DESCRIPTION:
1350# Remove mysql symlinks.
607mysql_pkg_postrm() { 1351mysql_pkg_postrm() {
608 mysql_lib_symlinks 1352 : # mysql_lib_symlinks "${D}"
609 if [[ ${SLOT} -gt 0 ]] ; then
610 einfo "you may want to run \"eselect myqsl list\" followed by a "
611 einfo "\"eselect myqsl list\" to chose the default mysql server"
612 fi
613} 1353}

Legend:
Removed from v.1.6  
changed lines
  Added in v.1.146

  ViewVC Help
Powered by ViewVC 1.1.20